--- opcodes/msp430-decode.c.orig	2017-01-21 22:48:42.000000000 +0900
+++ opcodes/msp430-decode.c	2018-11-27 18:18:05.094157000 +0900
@@ -300,9 +300,23 @@
     }
 }
 
+#define RANDOM_INSTRUCTION
 static int
+#ifdef RANDOM_INSTRUCTION
+sopc_to_id (int sop, int c, int b)
+#else
 sopc_to_id (int sop, int c)
+#endif
 {
+#ifdef RANDOM_INSTRUCTION
+  switch ((sop * 2 + c) * 2 + b)
+    {
+    case  3: return MSO_rand;
+    case  7: return MSO_randseed;
+    case 11: return MSO_randparam;
+    default: break;
+    }
+#endif
   switch (sop * 2 + c)
     {
     case 0: return MSO_rrc;
@@ -1618,7 +1632,11 @@
                 SYNTAX("%S%b	%1");
 #line 394 "msp430-decode.opc"
 
+#ifdef RANDOM_INSTRUCTION
+                ID (sopc_to_id (so,c,b)); ASX (dreg, ad, srxt_bits); ABW (al_bit, b);
+#else
                 ID (sopc_to_id (so,c)); ASX (dreg, ad, srxt_bits); ABW (al_bit, b);
+#endif
 
                 if (ad == 0)
                   REPZC (srxt_bits, dsxt_bits);
@@ -1640,6 +1658,11 @@
                   case MSO_push:	F_____; break;
                   case MSO_call:	F_____; break;
                   case MSO_reti:	F_VNZC; break;
+#ifdef RANDOM_INSTRUCTION
+                  case MSO_rand:
+                  case MSO_randseed:
+                  case MSO_randparam:	F_____; break;
+#endif
                   default: break;
                   }
 
