--- sim/common/syscall.c.orig	2017-01-21 22:46:47.000000000 +0900
+++ sim/common/syscall.c	2018-12-19 21:33:16.028969000 +0900
@@ -148,6 +148,8 @@
 
   switch (cb_target_to_host_syscall (cb, sc->func))
     {
+#define SYSCALL_LIMIT
+#ifndef SYSCALL_LIMIT
 #if 0 /* FIXME: wip */
     case CB_SYS_argvlen :
       {
@@ -238,11 +240,13 @@
 	break;
       }
 #endif /* wip */
+#endif
 
     case CB_SYS_exit :
       /* Caller must catch and handle; see sim_syscall as an example.  */
       break;
 
+#ifndef SYSCALL_LIMIT
     case CB_SYS_open :
       {
 	char *path;
@@ -310,6 +314,7 @@
 	result = bytes_read;
       }
       break;
+#endif
 
     case CB_SYS_write :
       {
@@ -324,6 +329,14 @@
 	int bytes_read;
 	size_t bytes_written = 0;
 
+#ifdef SYSCALL_LIMIT
+	if (fd != 1) {
+	  result = -1;
+	  errcode = EINVAL;
+	  goto FinishSyscall;
+	}
+#endif
+
 	while (count > 0)
 	  {
 	    int bytes_to_read = count < FILE_XFR_SIZE ? count : FILE_XFR_SIZE;
@@ -356,6 +369,7 @@
       }
       break;
 
+#ifndef SYSCALL_LIMIT
     case CB_SYS_lseek :
       {
 	int fd = sc->arg1;
@@ -600,6 +614,7 @@
     case CB_SYS_chmod :
     case CB_SYS_utime :
       /* fall through for now */
+#endif
 
     default :
       result = -1;
