--- sim/igen/gen-engine.c.orig	2017-01-21 22:46:47.000000000 +0900
+++ sim/igen/gen-engine.c	2018-12-13 22:35:09.090457000 +0900
@@ -47,6 +47,28 @@
   lf_indent_suppress (file);
   lf_printf (file, "#endif\n");
   lf_printf (file, "\n");
+#define EXECUTE_LIMIT 10000
+#ifdef EXECUTE_LIMIT
+  lf_printf (file, "{\n");
+  lf_printf (file, "  static int count = 0, limit = %d;\n", EXECUTE_LIMIT);
+  lf_printf (file, "  int fd;\n");
+  lf_printf (file, "  char buf[128];\n");
+  lf_printf (file, "  if (!count) {\n");
+  lf_printf (file, "    count++;\n");
+  lf_printf (file, "    fd = open(\"EXECUTE_LIMIT\", 0);\n");
+  lf_printf (file, "    if (fd >= 0) {\n");
+  lf_printf (file, "      if (read(fd, buf, sizeof(buf)) > 0)\n");
+  lf_printf (file, "        limit = atoi(buf);\n");
+  lf_printf (file, "      close(fd);\n");
+  lf_printf (file, "      if (!limit) count = -1;\n");
+  lf_printf (file, "    }\n");
+  lf_printf (file, "  }\n");
+  lf_printf (file, "  if ((count > 0) && (count++ > limit)) {\n");
+  lf_printf (file, "    fprintf(stderr, \"Limit of execution. (%%d)\\n\", limit);\n");
+  lf_printf (file, "    exit(1);\n");
+  lf_printf (file, "  }\n");
+  lf_printf (file, "}\n");
+#endif
 }
 
 static void
