#!/bin/sh

count=$1

rm -f encrypt/*
rm -f decrypt/*
mkdir -p encrypt
mkdir -p decrypt

./mkconfig.pl $count > config.h
./mkanswer.pl $count > key.h

echo "-------- build for encrypt --------"

make clean
make
make run

cp config.h key.h *.x *.d *.sot encrypt
make clean

echo "-------- build for decrypt --------"

enables="all"
expr "$count" + 1 > /dev/null 2>&1
if [ $? -lt 2 ]; then
	enables="bfin-elf"
	if [ "$count" -ge 15 ]; then
		enables="$enables msp430-elf"
	fi
	if [ "$count" -ge 30 ]; then
		enables="$enables arm-elf"
	fi
	if [ "$count" -ge 45 ]; then
		enables="$enables v850-elf"
	fi
	if [ "$count" -ge 60 ]; then
		enables="$enables mips-elf"
	fi
	if [ "$count" -ge 80 ]; then
		enables="$enables rl78-elf"
	fi
	if [ "$count" -ge 100 ]; then
		enables="$enables aarch64-elf"
	fi
	if [ "$count" -ge 130 ]; then
		enables="$enables mn10300-elf"
	fi
	if [ "$count" -ge 160 ]; then
		enables="$enables microblaze-elf"
	fi
	if [ "$count" -ge 190 ]; then
		enables="$enables mips64-elf"
	fi
	if [ "$count" -ge 200 ]; then
		enables="all"
	fi
fi

archs=`ls encrypt/*.sot | perl -pe 's/^encrypt\///' | perl -pe 's/\.sot//'`

if [ $enables = "all" ]; then
	enables=$archs
fi

for arch in $archs; do
	cat encrypt/${arch}.sot | ./bin2c.pl $count > key.h
	make clean ; make ${arch}.d
	/home/user/tools/cross-gcc494/bin/${arch}-strip ${arch}.x
	make ${arch}.sot
	for enable in $enables; do
		if [ $arch = $enable ]; then
			cp ${arch}.x ${arch}.d ${arch}.sot decrypt
		fi
	done
done

make clean
rm -f config.h key.h
