/*
 * Sample: (rev32 instruction)
 *   fe1660:       dac00841        rev32   x1, x2
 * Ref: gdb-7.12.1/sim/aarch64/simulator.c:dexDataProc1Source()
 * (Caution: instr[28,21] = 11010110 (Bug of comment)
 *
 *      instr[30]    = 1
 *      instr[28,21] = 111010110
 *      instr[31]    = size : 0 ==> 32 bit, 1 ==> 64 bit
 *      instr[29]    = S : 0 ==> ok, 1 ==> UNALLOC
 *      instr[20,16] = opcode2 : 00000 ==> ok, ow ==> UNALLOC
 *      instr[15,10] = opcode : 000000 ==> RBIT, 000001 ==> REV16,
 *                              000010 ==> REV, 000011 ==> UNALLOC
 *                              000100 ==> CLZ, 000101 ==> CLS
 *                              ow ==> UNALLOC
 *      instr[9,5]   = rn : may not be SP
 *      instr[4,0]   = rd : may not be SP.
 */
unsigned long xorshift_param(unsigned long param)
{
  asm volatile (".int 0xdac06000"); /* xorshiftparam instruction */
  return param;
}

unsigned long xorshift_seed(unsigned long seed)
{
  asm volatile (".int 0xdac03c00"); /* xorshiftseed instruction */
  return seed;
}

unsigned long xorshift_value(unsigned long value)
{
  asm volatile (".int 0xdac03800"); /* xorshift instruction */
  return value;
}
