#!/bin/sh

. /home/user/server/files/param.sh

inetdc=$homedir/simple-inetd-connect/simple-inetd-connect
inetd=$homedir/simple-inetd/simple-inetd
timerdir=$homedir/timer-exec
timer=timer-exec
commitdir=$homedir/commit
commit=commit
htmldir=/var/www/html
startport=10000
gid=10000
limit=120

su -l user -c "$serverdir/files/check.pl /tmp/simple-inetd-connect.log 3" &

su -l user -c "$serverdir/files/update.pl $execsimdir $homedir/tmp $htmldir" &

$inetd any 9999 0 0 $timerdir $timer $timer 10 9 1000 1000 \
	NOCHROOT $commitdir/$commit $commit \
		$homedir/tmp/key.h \
		$htmldir/flag.txt \
		$homedir/tmp/count.txt \
		$homedir/commit.sh FROM_ADDRESS TIME RESULT >> $homedir/tmp/error.log &

for u in $users; do
    archparam $u

    opt=
    gdb=$arch-gdb
    case $arch in
	powerpc-elf)     opt="-e linux" ;;
	bfin-elf)        opt="--environment user" ;;
	mips64-elf)      opt="--memory-region 0x100000,0x10000" ;;
	arm16-elf)       gdb="arm-elf-gdb" ;;
	mips64-elf)      gdb="mips-elf-gdb" ;;
	powerpc64-linux) gdb="powerpc-elf-gdb" ;;
    esac

    $inetdc any $port 0 0 \
	$timerdir $timer $timer $limit 9 $uid $gid \
	/home/$user /bin/rungdb.sh rungdb.sh \
		RANDPORT $limit /bin/gdb/$gdb /bin/exec/$arch.x $opt &
done
