#!/usr/bin/perl
#
# Example:
# update.pl /home/user/exec-sim /home/user/tmp /var/www/html

$execdir = shift(@ARGV);
$tmpdir  = shift(@ARGV);
$htmldir = shift(@ARGV);

$next = 0;
$status = 0;

while (1) {
	$interval = `cat $tmpdir/interval.txt 2> /dev/null`;

	if ($interval =~ /^pause/) {
		sleep(1);
		next;
	} elsif ($interval =~ /^force/) {
		# none
	} elsif ($interval == 0) {
		$interval = 5;
	}

	$t = time;

	$sleepsec = 1;
	if ($t >= $next) {
		($sec, $min, $hour) = localtime($t);
		if ($status == 0) {
			output_log("ready begin (old status: $status)");
			$status = ready_service();
			output_log("ready end (new status: $status)");
			($nmin, $nsec) = ($interval - 1, 50);
		} elsif ($status == 1) {
			output_log("stop begin (old status: $status)");
			$status = stop_service();
			output_log("stop end (new status: $status)");
			($nmin, $nsec) = (0, 10);
		} elsif ($status == 2) {
			output_log("start begin (old status: $status)");
			$status = start_service($sec, $min, $hour);
			output_log("start end (new status: $status)");
			($nmin, $nsec) = (0, 20);
		}
		$t = time;
		if ($interval =~ /^force/) {
			$next = $t + 5;
		} else {
			$next = nexttime($nmin, $nsec, $t, $interval);
			$sleepsec = $next - $t;
		}
	}

	sleep($sleepsec);
}

sub ready_service {
	my $i;
	my $n;
	my $f;
	my $key;
	my $k;
	my $c;
	my @files;
	my $mes;

	$mes = "cannot update";

	for ($i = 0; $i < 5; $i++) {
		$c = `cat $tmpdir/count.txt 2> /dev/null`;
		$c =~ s/\n$//;

		system("cd $execdir ; ./make.sh $c > /dev/null 2>&1");

		$key = `cat $execdir/encrypt/key.h 2> /dev/null`;
		$key =~ s/[\"\r\n]//g;

		@files = `ls $execdir/decrypt/*.sot 2> /dev/null`;
		chomp(@files);

		$n = @files;
		if ($n == 0) { next; }

		$f = $files[int(rand($n))];
		$k = `cat $f 2> /dev/null`;
		$k =~ s/[\"\r\n]//g;

		if ($key ne $k) {
			output_log("$f error (key: $k)");
			next;
		}

		$f =~ s/\.sot$/\.x/;

		system("cp $execdir/encrypt/key.h $tmpdir/key.h.next");
		system("cp $execdir/encrypt/config.h $tmpdir/config.h.next");
		system("cp $f $tmpdir/runme.x.next");

		$mes = "$f selected";

		last;
	}

	output_log("$mes (count: $c)");

	return 1;
}

sub stop_service {
	system("rm -f $tmpdir/key.h");
	return 2;
}

sub start_service {
	my $log;
	my $s;
	my $m;
	my $h;

	($s, $m, $h) = @_;

	$log = sprintf "%02d:%02d:%02d", $h, $m, $s;
	$log .= " runme.x renewal";
	`echo "---- $log ----" >> $htmldir/flag.txt`;

	system("cp $tmpdir/key.h.next $tmpdir/key.h");
	system("cp $tmpdir/config.h.next $tmpdir/config.h");
	system("cp $tmpdir/runme.x.next $tmpdir/runme.x");
	system("cp $tmpdir/runme.x $htmldir");

	return 0;
}

sub output_log {
	my $log;
	my $s;
	my $m;
	my $h;
	my $mes;

	($mes) = @_;

	($s, $m, $h) = localtime(time);

	$log = sprintf "%02d:%02d:%02d", $h, $m, $s;
	$log .= " $mes";
	`echo "$log" >> $tmpdir/update.log`;
}

sub nexttime
{
	my $nmin;
	my $nsec;
	my $t;
	my $i;
	my $min;
	my $sec;
	my $w;

	($nmin, $nsec, $t, $i) = @_;
	($sec, $min) = localtime($t);

	$w = ($nmin * 60 + $nsec) + ($i * 60) - (($min % $i) * 60 + $sec);
	$t += $w % ($i * 60);

	return $t;
}
