/*
 * Write operation is not implemented on MicroBlaze simulator in GDB.
 * See gdb/sim/microblaze/interp.c:process_stub(),handle_trap1()
 * (handle_trap1() is empty function)
 * And printf utility is not implemented too.
 * See gdb/sim/microblaze/interp.c:util() (case 1:)
 */

	.section .text

	.globl	_start
	.type	_start, @function
_start:
	addik	r1, r0, _estack
	brlid	r15, main
	nop

	addk	r5, r3, r0
	/* fall through */

	.globl	__exit
	.type	__exit, @function
__exit:
	/*
	 * Use halt instruction.
	 * See gdb/sim/microblaze/interp.c:sim_resume()
	 * (MICROBLAZE_HALT_INST, SIGQUIT)
	 * Exit code is by r3.
	 * See gdb/sim/microblaze/interp.c:sim_stop_reason() (RETREG)
	 */
	addk	r3, r5, r0
	.long	0xb8000000
	rtsd	r15, 8
	nop

#define BRK_SYSCALL_READ  3
#define BRK_SYSCALL_WRITE 4
#define BRK_SYSCALL_OPEN  5
#define BRK_SYSCALL_CLOSE 6

	.globl	__read
	.type	__read, @function
__read:
	addik	r1, r1, -16
	addik	r3, r0, BRK_SYSCALL_READ
	swi	r3, r1, 0
	swi	r5, r1, 4
	swi	r6, r1, 8
	swi	r7, r1, 12
	addk	r5, r1, r0
	brk	r3, r5
	rtsd	r15, 8
	addik	r1, r1, 16

	.globl	__write
	.type	__write, @function
__write:
	addik	r1, r1, -16
	addik	r3, r0, BRK_SYSCALL_WRITE
	swi	r3, r1, 0
	swi	r5, r1, 4
	swi	r6, r1, 8
	swi	r7, r1, 12
	addk	r5, r1, r0
	brk	r3, r5
	rtsd	r15, 8
	addik	r1, r1, 16

	.globl	__open
	.type	__open, @function
__open:
	addik	r1, r1, -16
	addik	r3, r0, BRK_SYSCALL_OPEN
	swi	r3, r1, 0
	swi	r5, r1, 4
	swi	r6, r1, 8
	swi	r7, r1, 12
	addk	r5, r1, r0
	brk	r3, r5
	rtsd	r15, 8
	addik	r1, r1, 16

	.globl	__close
	.type	__close, @function
__close:
	addik	r1, r1, -8
	addik	r3, r0, BRK_SYSCALL_CLOSE
	swi	r3, r1, 0
	swi	r5, r1, 4
	addk	r5, r1, r0
	brk	r3, r5
	rtsd	r15, 8
	addik	r1, r1, 8
